VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CRequest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'/////////////////////////////////////////////////////////////////////////////////////////////////
'//
'// Class       :   CRequest
'// Description :   This class represents a request to the Government Gateway.  It wraps a
'//                 CMessage object that is the XML GovTalk message itself.  It also aggregates a
'//                 CResponse object that is the response that the Gateway sent to us in reply
'//                 to this message.
'//
'/////////////////////////////////////////////////////////////////////////////////////////////////
'//
'//

Option Explicit

Private mobjMessage As CMessage     ' The request XML message itself
Private mobjResponse As CResponse   ' The response generated by the request


'/////////////////////////////////////////////////////////////////////////////////////////////////
'// Name:   Class_Terminate()
'//         Clean up the object.
'//
'/////////////////////////////////////////////////////////////////////////////////////////////////
Private Sub Class_Terminate()
    Set mobjMessage = Nothing
    Set mobjResponse = Nothing
End Sub

'/////////////////////////////////////////////////////////////////////////////////////////////////
'// Name:   Property Get/Set Message()
'//         Get / Set the GovTalk XML message object that we wrap
'//
'/////////////////////////////////////////////////////////////////////////////////////////////////
Public Property Get Message() As CMessage
    Set Message = mobjMessage
End Property
Public Property Set Message(obj As CMessage)
    Set mobjMessage = obj
End Property



'/////////////////////////////////////////////////////////////////////////////////////////////////
'// Name:   Property Get/Set Response()
'//         Get / Set the GovTalk Response that the Gateway generated in response to this message.
'//
'/////////////////////////////////////////////////////////////////////////////////////////////////
Public Property Get Response() As CResponse
    Set Response = mobjResponse
End Property

Public Property Set Response(obj As CResponse)
    Set mobjResponse = obj
End Property

'/////////////////////////////////////////////////////////////////////////////////////////////////
'// Name:   Property Let/Get XML()
'//         Get / Set request Govtalk XML message
'//
'/////////////////////////////////////////////////////////////////////////////////////////////////
Public Property Let XML(ByVal strXML As String)

    On Error GoTo Handler
    
    Set mobjMessage = New CMessage
    
    mobjMessage.XML = strXML
    
    Exit Property
Handler:
    Err.Raise Err.Number, Err.Source, Err.Description
        
End Property

Public Property Get XML() As String
    On Error GoTo Handler
    
    XML = mobjMessage.XML
    
    Exit Property
Handler:
    XML = ""
End Property

